### MQTT交互接口



上行payload中的公共参数

```javascript
{
    "version": {version},
    "device_id": {device_id},
    "lan_ip": {lan_ip},
    "timestamp": {timestamp}
}
```

version、device_id、lan_ip都是字符型，timestamp是整型，13位数的时间戳



#### 上行

| Function         | Topic                                                    | Payload                                                      | Remark                          |
| ---------------- | -------------------------------------------------------- | ------------------------------------------------------------ | ------------------------------- |
| 关机上报         | /{productID}/{deviceName}/up/device_state_changed        | {"version": {version}, "device_id": {device_id}, "lan_ip": {lan_ip}, "timestamp": {timestamp}, "params": {"state": "off",  "auto": true}} | 自动关机auto传true，手动传false |
| 开机上报         | /{productID}/{deviceName}/up/device_state_changed        | {"version": {version}, "device_id": {device_id}, "lan_ip": {lan_ip}, "timestamp": {timestamp}, "params": {"state": "on"}} |                                 |
| 指令执行完成上报 | /{productID}/{deviceName}/up/commands_execution_finished | {"version": {version}, "device_id": {device_id}, "lan_ip": {lan_ip}, "timestamp": {timestamp}, "params": {"success": true}} | 成功传true，失败传false         |
| 资源更新完成     | /{productID}/{deviceName}/up/resource_updated            | {"version": {version}, "device_id": {device_id}, "lan_ip": {lan_ip}, "timestamp": {timestamp}, "params": {"resource_id": {resource_id}} |                                 |
| 缓存数据超时     | /{productID}/{deviceName}/up/cache_timed_out             | {"version": {version}, "device_id": {device_id}, "lan_ip": {lan_ip}, "timestamp": {timestamp}, "params": {"cache_id": {cache_id}} |                                 |



#### 下行

| Function            | Topic                                                | Payload                          | Remark              |
| ------------------- | ---------------------------------------------------- | -------------------------------- | ------------------- |
| 资源下载地址        | /{productID}/{deviceName}/down/resource_download_url | {"resource_url": {resource_url}  |                     |
| 资源上传id          | /{productID}/{deviceName}/down/resource_upload_id    | {"resource_id": {resource_id}}   | resource_id为字符型 |
| 资源上传地址        | /{productID}/{deviceName}/down/resource_upload_url   | {"resource_url": {resource_url}} |                     |
| 心跳间隔最大周期(s) | /{productID}/{deviceName}/down/heartbeat_max_seconds | {"seconds": {seconds}}           | seconds为整型       |

 b 